<template>

  <div class="movie_item">
    <router-link :to="'/movie/' + movie.id" >
      <img class="movie_item_img" 
      alt="movie-poster" src="" ref="image"
         v-in-view-observer:once @inView="loadImage" />
    </router-link>
    <div class="movie_item_details">
      <div class="movie_item_title">
        {{ movie.title }}
      </div>
      <div class="movie_item_year">
        {{ movie.release_date | formatYear }}
      </div>
      <div class="movie_item_genre">
        {{ movie.genres|formatArrayToString }}
      </div>
    </div>
  </div>

</template>

<script>
import formatYear from "@/filters/format-year-filter"

export default {
  name: "MovieItem",
  props: {
    movie: {
      type: Object,
      required: true
    }
  },
  filters: {
    formatArrayToString: genres => {
      return genres.join(', ');
    },
    formatYear: formatYear
  },
  methods: {
    loadImage: function () {
      this.$refs.image.src = this.movie.poster_path
    }
  }
};
</script>

<style scoped lang="scss">
.movie_item {
  width: 300px;
  margin: 40px 40px 0;
  display: flex;
  flex-flow: column wrap;
  color: #fff;
  font-family: "Montserrat", sans-serif;
}
.movie_item_img {
  width: 100%;
  height: 450px;
}
.movie_item_details {
  display: flex;
  flex-flow: row wrap;
  align-items: center;
  justify-content: space-between;
  margin-top: 10px;
  opacity: 0.8;
}
.movie_item_title {
  width: 70%;
}
.movie_item_year {
  padding: 3px 10px;
  border: 1px solid #666;
  border-radius: 5px;
}
.movie_item_genre {
  margin: 8px 0;
  opacity: 0.7;
}
</style>
